<?php
	$rcsid = "\$Fuller: myprograms/htbm/web/bookmarks.php,v 1.46 2004/12/14 17:42:06 fullermd Exp $";

	/* Include our stuff */
	$rootdir = ".";
	include("${rootdir}/php/main.php");

	/* Start up */
	$db = db_connect();

	/* Suck in our big config array */
	if(isset($_REQUEST['conf']))
		$conf = unserialize(base64_decode($_REQUEST['conf']));
	else
		$conf = array();

	/* Provide some default checks */
	if(!isset($conf['admin']))
		$conf['admin']=0;
	if(!isset($conf['debug']))
		$conf['debug']=$def_debug;
	if(!isset($conf['expandall']))
		$conf['expandall']=$def_expandall;
	if(!isset($conf['expanders']))
		$conf['expanders']=array();

	/* Default the other way */
	if(isset($conf['bounceback']))
		unset($conf['bounceback']);

	/* Conf overrides */
	/* Admin mode */
	if(isset($_REQUEST['admin']))
	{
		/* If we're in admin mode and leaving, kill the cookie */
		if( ($conf['admin']==1) && ($_REQUEST['admin']==0) )
			setcookie("HTBMauth", $_COOKIE['HTBMauth'], time()-3600);

		$conf['admin'] = $_REQUEST['admin'];
	}
	
	/* Debug override */
	if(isset($_REQUEST['debug']))
		$conf['debug'] = $_REQUEST['debug'];

	/* Expand/unexpand/collapse all */
	if($_REQUEST['expandall']=="yes")
		$conf['expandall'] = 1;
	else if($_REQUEST['expandall']=="no")
		$conf['expandall'] = 0;
	else if($_REQUEST['expandall']=="collapse")
	{
		$conf['expandall'] = 0;
		$conf['expanders'] = array();
	}

	/* Expand/collapse individual sections */
	if(isset($_REQUEST['expand']))
	{
		$exp = $_REQUEST['expand'];

		if($exp>0)
			array_push($conf['expanders'], $exp);
		else
		{
			$loc=array_search(-($exp), $conf['expanders']);
			if($loc !== FALSE)
				array_splice($conf['expanders'], $loc, 1);
		}
	}

	/* Super-overrides */
	if($def_debug==-1) /* Can't be countermanded */
		$conf['debug']=0;

	/* Re-encode */
	$confenc = base64_encode(serialize($conf));


	/* If we're in admin mode, try authenticating */
	if($admin_auth_req==1 && $conf['admin']==1)
	{
		$dbtmp = $conf['debug'];
		$conf['debug']=0;
		admin_auth();
		$conf['debug'] = $dbtmp;
	}

	/* Some heading stuff */
	print_head("Bookmarks", $rcsid);

	/* Be a bit sneaky */
	printf(" <h1 class=\"center\">My bookmarks%s</h1>\n",
			($conf['admin']==1) ? " (admin mode)" : "");

	/* Build up our categories */
	$categories = build_categories();

	/* And our bookmarks */
	$bookmarks = build_bookmarks();

	/* Put out [un]expandall links */
	print_expandcollapse();

	/* Print out admin-type links */
	print_admin();

	/* Debug mode */
	if($def_debug!=-1)
	{
		if($conf['debug']==1)
		{
			$dval=0;
			$dact="Disable";
		}
		else
		{
			$dval=1;
			$dact="Enable";
		}

		print <<< _EOF_
<ul class="metalink">
 <li>
  <a href="$self?conf=$confenc&amp;debug=$dval">$dact debugging</a>
 </li>
</ul>

_EOF_;
	}


	/*
	 * List our subcategories (and their children, depending on
	 * expansion).
	 */
	$catpath = "C0";
	listkids(0);

	/*
	 * List any bookmarks that are just in the root; easier to do this
	 * than to hack up listkids() to special case '0'.
	 */
	listmarks(0);

	/* Now our footer */
	print_foot();

	/* And that's all she wrote */
	exit(0);
?>
