<?php
/* $Fuller: myprograms/htbm/web/php/admin_cat.php,v 1.18 2004/12/11 15:43:39 fullermd Exp $ */

/* Admin stuff for categories */

/* Print out a form for new/edit categories */
function print_cat_form($catinfo)
{
	global $db;
	global $amode;
	global $alreadysel;
	global $cdepth;
	global $confenc;
	global $self;

	$cat_id = $catinfo['cat_id'];
	$parents = $catinfo['parents'];
	$name = $catinfo['name'];

	/* Check if we have a cat_id and handle. */
	if($cat_id>0)
	{
		/* If it already exists, see what sort of children it has */
		$cid_q = db_quote($cat_id);
		$querystr = "SELECT COUNT(DISTINCT bl.mark_id) AS nmarks, "
				. "COUNT(DISTINCT cl.cat_id) AS ncats "
				. "FROM categories c FULL JOIN bm_links bl "
				. "ON (bl.parent=c.cat_id) FULL JOIN cat_links cl "
				. "ON (cl.parent=c.cat_id) "
				. "WHERE c.cat_id=$cid_q";
		$result = db_query($querystr);
		$temp = db_getrow($result);
		$nbm = db_dequote($temp['nmarks']);
		$nsc = db_dequote($temp['ncats']);
		db_qfree($result);

		print("<p>$nbm bookmarks, $nsc sub-categories</p>\n");
	}

	/* Category info */
	if($amode=="catdele")
		$ro = " readonly=\"readonly\" ";
	else
		$ro = "";

	if($amode=="catedit")
	{
		print <<< _EOF_
<h2>General</h2>
<form action="$self" method="post">

_EOF_;
		if($cat_id>0)
			$cat_tit = <<< _EOF_
</ul>
<p>
 <input type="hidden" name="amode" value="$amode" />
 <input type="hidden" name="conf" value="$confenc" />
 <input type="hidden" name="cat_id" value="$cat_id" />
 <input type="submit" name="commit" value="Commit" />
</p>
</form>
<h2>Parents</h2>
<ul>

_EOF_;
		else
			$cat_tit = "";
	}
	else
		$cat_tit = "";

	/* XXX This should be prettified.  A lot. */
	$name_e = htmlentities($name);

	print <<< _EOF_
<ul>
 <li>
  Name: <input type="text" size="30" name="name" value="$name_e" $ro/>
 </li>
$cat_tit

_EOF_;

	/* Figure out what categories we have */
	$categories = build_categories(); /* Kinda a cheat 8-) */

	/* Go through the parents one at a time */
	$i=0;
	if($amode=="catdele")
	{
		/* Just list all the parents */
		foreach($parents as $dummy => $thisparent)
			print("<li>Parent: " . htmlentities($thisparent)
					. "</li>\n");
	}
	else
	{
		/* Put 'em in selects */
		foreach($parents as $dummy => $thisparent)
		{
			print(" <li>\n");

			if($cat_id>0)
				print <<< _EOF_
 <form method="post" action="$self">
  <p>
   Parent:
   <select name="parent">
_EOF_;
			else
				print("  Parent category: <select name=\"parent\">");

			/* Top level */
			if($thisparent==0)
			{ $seld = " selected=\"selected\""; }
			else
			{ $seld = ""; }
			print("<option value=\"0\"$seld>Bookmarks</option>");

			/* Print the rest */
			$alreadysel=0;
			$cdepth=1;
			select_listkids(0,$thisparent,$categories);

			/* Done categories */
			print("</select>\n");

			if($cat_id>0)
				print <<< _EOF_
   <input type="hidden" name="old_parent" value="$thisparent" />
   <input type="hidden" name="amode" value="$amode" />
   <input type="hidden" name="cat_id" value="$cat_id" />
   <input type="hidden" name="conf" value="$confenc" />
   <input type="submit" name="ed_chpar" value="Update" />
   <input type="submit" name="ed_delpar" value="Delete" />
  </p>
 </form>
_EOF_;

			print("</li>\n");

			$i++;
		}
	}
	print("</ul>\n");

	/* If we're editing, allow adding parents */
	if( ($cat_id>0) && ($amode=="catedit") )
	{
		print <<< _EOF_
<h2>Add new parent</h2>
<ul>
 <li>
  <form method="post" action="$self">
   <p>
    Category:
    <select name="parent">
_EOF_;

		/* Top level */
		print("<option value=\"0\">Bookmarks</option>");

		/* Print the rest */
		/* XXX Kinda a dummy, no selected'd being done */
		$cdepth=1;
		select_listkids(0,-1,$categories);

		/* Done categories */
		print <<< _EOF_
</select>
    <input type="hidden" name="cat_id" value="$cat_id" />
    <input type="hidden" name="amode" value="$amode" />
    <input type="hidden" name="conf" value="$confenc" />
    <input type="submit" name="ed_addpar" value="Add" />
   </p>
  </form>
 </li>
</ul>

_EOF_;
		/* Done with new parent adding */
	}
	else if( ($cat_id==0) && ($amode=="catedit") )
		/* New category, just give a submit */
		print <<< _EOF_
<p>
 <input type="hidden" name="amode" value="$amode" />
 <input type="hidden" name="cat_id" value="$cat_id" />
 <input type="hidden" name="conf" value="$confenc" />
 <input type="submit" name="commit" value="Commit" />
</p>
</form>

_EOF_;

	/* That's all */
}

?>
