<?php
/* $Fuller: myprograms/htbm/web/php/categories.php,v 1.20 2004/12/14 12:13:27 fullermd Exp $ */

/* Ugly-ass hack to deal with damnfool scoping between these functions */
$buildcat=array();
$childpath=array();

function build_categories()
{
	global $debug;
	global $db;
	global $buildcat;
	global $childpath;

	# If we're in 'normal' mode, over-protect ourselves.
	if($debug!=1)
	{ $buildcat = array(); }

	/* Grab all the info from the 'categories' */
	$query = <<< _EOF_
SELECT
  c.cat_id AS cat_id,
  c.name AS name,
  COUNT(DISTINCT cl.cat_id) AS nkids,
  COUNT(DISTINCT bl.mark_id) AS nmarks
FROM
  categories c LEFT JOIN cat_links cl ON (cl.parent=c.cat_id)
    LEFT JOIN bm_links bl ON (bl.parent=c.cat_id)
GROUP BY
  c.cat_id,c.name
ORDER BY
  name
_EOF_;

	$result = db_query($query);

	while($row = db_getrow($result))
	{
		$cid = db_dequote($row['cat_id']);
		$name = db_dequote($row['name']);
		$nkids = db_dequote($row['nkids']);
		$nmarks = db_dequote($row['nmarks']);

		/* Register our info */
		$buildcat[$cid]['cid'] = $cid;
		$buildcat[$cid]['name'] = $name;

		$buildcat[$cid]['has_children'] = $nkids;
		$buildcat[$cid]['has_bookmarks'] = $nmarks;
		$buildcat[$cid]['children'] = array();
		$buildcat[$cid]['parents'] = array();
		$buildcat[$cid]['bookmarks'] = array();
	}
	db_qfree($result);


	/*
	 * Now build the list of actual 'parent' links.
	 */
	$querystr = "SELECT cl.cat_id,parent,name "
			. "FROM cat_links cl INNER JOIN categories USING (cat_id) "
			. "ORDER BY name";
	$result = db_query($querystr);
	while($row = db_getrow($result))
	{
		$cid = db_dequote($row['cat_id']);
		$parent = db_dequote($row['parent']);
		/* Only using 'name' for sorting porpoises */

		/* Sanity: We should never, ever, ever have $cid==0 */
		if($cid==0)
		{
			d_print("<p>Error: cat_id=0 found in cat_links!</p>\n");
			continue;
		}

		/* Register parent/child links */
		array_push($buildcat[$cid]['parents'], $parent);
		array_push($buildcat[$parent]['children'], $cid);
	}
	db_qfree($result);

	/* Walk the list looking for loops; remove any we find */
	$childpath = array();
	check_loop(0);


	/*
	 * Now build the list of bookmarks per category.
	 */
	$querystr = "SELECT bl.mark_id,parent,title "
			. "FROM bm_links bl INNER JOIN bookmarks b USING (mark_id) "
			. "ORDER BY title";
	$result = db_query($querystr);
	while($row = db_getrow($result))
	{
		$mid = db_dequote($row['mark_id']);
		$parent = db_dequote($row['parent']);
		/* We don't use title, we just used it to sort by above */

		/* Register into our category */
		array_push($buildcat[$parent]['bookmarks'], $mid);
	}
	db_qfree($result);

	return($buildcat);
}


/* Recursive search of children for loops */
function check_loop($cid)
{
	global $childpath;
	global $debug;
	global $buildcat;

	$mykids = $buildcat[$cid]['children'];

	if(!$mykids)
	{
		/*
		 * We have no children.  Take ourselves off the list, and back up
		 * to the last level.
		 */
		array_pop($childpath);
		return;
	}

	/* Check if any of our kids have been traversed already */
	if( $isect = array_intersect($mykids, $childpath) )
	{
		/*
		 * Whoopsy, we've got LOOPS!  Bad monkey!
		 * Bitch about each one, and take it out.
		 */
		foreach($isect as $dummy => $dup)
		{
			$err = sprintf("<!-- Category '%d' ('%s') encountered as child "
					. "of category '%d' ('%s'), but is also a parent.  Loops "
					. "are bad, mmkay? -->\n",
					$dup, $buildcat[$dup]['name'],
					$cid, $buildcat[$cid]['name']);
			d_print($err);
			if($admin || $debug)
			{
				print("<p style=\"text-weight: bold;\">\n");
				print("WARNING!  Category '$dup' ("
						. $buildcat[$dup]['name'] . ") "
						. "is listed as child of "
						. "'$cid' (" . $buildcat[$cid]['name'] . ")"
						. ", but is also an ancestor of it!\n");
				print("</p>\n");
			}
		}

		/*
		 * I think there's a better way to do this with
		 * array_splice(), but I'm not quite clear on how it works.
		 * I'm too lazy to figure it out right now, so we'll do this
		 * manually.
		 * Doing it this way is much more efficient if we do it in bulk;
		 * if we find a better way to just chop an item out of the array
		 * (I'm almost certainly you can with array_splice()), do it in
		 * the loop above.
		 */
		$newkids = array();
		while($item = array_shift($mykids))
			if(!(in_array($item, $childpath)))
				array_push($newkids, $item);
		$mykids = $newkids;
		$buildcat[$cid]['children'] = $newkids;
	}

	/*
	 * Done checking our kids; now check each of our kids in turn for
	 * THEIR kids.
	 */
	foreach($mykids as $dummy => $thiskid)
	{
		array_push($childpath, $thiskid);
		check_loop($thiskid);
	}

	/* Done with our kids' kids. */
	array_pop($childpath);
	return;

	/* Fin */
}

?>
