<?php
/* $Fuller: myprograms/htbm/web/php/dbfuncs.php,v 1.11 2004/12/14 12:09:12 fullermd Exp $ */


/* Connect to the database */
function db_connect()
{
	/* Suck in vars */
	global $dbuser, $dbpass, $dbhost, $dbport, $dbdb;

	/* Build our connection string */
	$cstr = "";
	if(isset($dbhost))
		$cstr .= "host=$dbhost ";
	if(isset($dbport))
		$cstr .= "port=$dbport ";
	$cstr .= "user=$dbuser password=$dbpass dbname=$dbdb";

	$db = pg_connect($cstr);

	if(pg_connection_status($db) !== PGSQL_CONNECTION_OK)
		die(pg_last_error($db));

	return($db);
}


/* Run a query, with error-checking */
function db_query($query)
{
	global $db;
	global $q_debug;
	global $conf;
	global $nquery;

	if($q_debug==1)
		print("<p style=\"font-weight:bold;\">Query is '"
				. htmlentities($query) . "'</p>\n");
	d_print("<!-- Query is '" . htmlentities($query) . "' -->\n");

	$result = pg_query($db, $query);
	if($result===FALSE)
	{
		print("<p style=\"font-weight:bold;\">DB Error: "
				.  pg_result_error($result) . "</p>\n");
		return(NULL);
	}

	$nquery++;
	return($result);
}


/* Get a row */
function db_getrow($result)
{ return(pg_fetch_array($result)); }


/* How many rows? */
function db_numrows($result)
{ return(pg_num_rows($result)); }


/* Finish and clean up a query */
function db_qfree($result)
{ return(pg_free_result($result)); }


/* Quote/escape something to use in a query */
function db_quote($str)
{
	global $db;

	if( (!isset($str)) || (strlen($str)==0) )
		return("NULL");
	else
		return("'" . pg_escape_string($str) . "'");
}


/* De-quote something out of the database */
function db_dequote($str)
{ return(stripslashes($str)); }

?>
